
package de.ivu.elect.exchange.benutzer.xml;

import de.ivu.elect.business.benutzerverwaltung.control.BenutzerExchangeContext;
import de.ivu.elect.business.benutzerverwaltung.entity.Benutzer;
import de.ivu.elect.business.datei.entity.FileType;
import de.ivu.elect.business.exchange.control.FileFormat;
import de.ivu.elect.business.exchange.control.FileKonfiguration;
import de.ivu.elect.business.exchange.control.MappingException;
import de.ivu.elect.exchange.benutzer.AbstractDefaultBenutzerMapper;
import de.ivu.elect.jee.exchange.Violations;
import de.ivu.elect.jee.exchange.XmlMarshaller;

import javax.inject.Inject;
import javax.xml.bind.JAXBException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;

public class DefaultXmlBenutzerMapper extends AbstractDefaultBenutzerMapper<DefaultXmlBenutzer> {

  @Inject
  protected transient XmlMarshaller<DefaultXmlBenutzerListe> xmlMarshaller;

  @Override
  protected DefaultXmlBenutzer createBenutzer() {
    return new DefaultXmlBenutzer();
  }

  protected DefaultXmlBenutzerListe mappeBenutzerInternToExtern(List<Benutzer> benutzerListe) {
    DefaultXmlBenutzerListe result = new DefaultXmlBenutzerListe();
    for (Benutzer benutzer : benutzerListe) {
      result.getBenutzer().add(mappeBenutzer(benutzer));
    }

    return result;
  }

  protected List<Benutzer> mappeBenutzerExternToIntern(DefaultXmlBenutzerListe benutzerListe) {
    List<Benutzer> result = new ArrayList<>(benutzerListe.getBenutzer().size());
    for (DefaultXmlBenutzer benutzer : benutzerListe.getBenutzer()) {
      result.add(mappeBenutzer(benutzer));
    }

    return result;
  }

  @Override
  public FileFormat getFileFormat() {
    return new FileFormat(FILE_FORMAT_NAME, FileType.XML);
  }

  @Override
  public void serialize(List<Benutzer> object, OutputStream os, BenutzerExchangeContext context, FileKonfiguration fileKonfiguration)
      throws MappingException {
    try {
      xmlMarshaller.serialize(mappeBenutzerInternToExtern(object), os);
    } catch (JAXBException e) {
      throw new MappingException(e.getMessage(), e);
    }
  }

  @Override
  public List<Benutzer> deserialize(InputStream is, BenutzerExchangeContext context, FileKonfiguration fileKonfiguration)
      throws MappingException {
    try {
      return mappeBenutzerExternToIntern(xmlMarshaller.deserialize(DefaultXmlBenutzerListe.class, is));
    } catch (JAXBException e) {
      throw new MappingException(e.getMessage(), e);
    }
  }

  @Override
  public Violations validateInputFormat(InputStream is, BenutzerExchangeContext context, FileKonfiguration fileKonfiguration) {
    return new Violations();
  }

  @Override
  public boolean isAcceptContext(BenutzerExchangeContext context) {
    return true;
  }
}
